#####################################################################
#
#       Copyright : Roshan Kumar Singh <singh.roshan08@gmail.com>
#       Licenced under GPLv2 or later.
#       Copyright: See License file that comes with this distribution
#
#####################################################################
import xmlrpclib, httplib, base64

class Blog:
	'''Class to store the details of the blog'''
	def __init__(self, url, username, password, proxyEnable, host, port, proxyUsername, proxyPassword, blogType):
		self.url = url
		self.server = ''
		puser_pass = ''
		if url != '':
			if proxyEnable == '1':
				p = ProxiedTransport()
				proxy = '%s:%s' % (host, port)
				if len(proxyUsername.strip()) != 0:
					puser_pass = base64.encodestring('%s:%s' % (proxyUsername, proxyPassword)).strip()
				p.set_proxy(proxy, puser_pass)
				self.server = xmlrpclib.Server(url, transport=p)
			else:
				self.server = xmlrpclib.ServerProxy(url)
		self.blogType = blogType
		self.username = username
		self.password = password
		self.proxyUsername = proxyUsername
		self.proxyPassword = proxyPassword
		self.proxyEnable = proxyEnable
		self.host = host
		self.port = port
		self.posts = []
		self.postedCategory = []

class Post:
	'''Class to store the contents like blog entry or pages'''
	#type denotes page or blog entry, default is blog entry
	def __init__(self):	
		self.type = 1
		self.title = ''
		self.body = ''
		self.category = []
		self.tags = ''
		self.postId = -1
		self.isPublished = 0

class ProxiedTransport(xmlrpclib.Transport):
	'''Class to enable proxy'''
	# Taken from http://docs.python.org/library/xmlrpclib.html#example-of-client-usage
	def set_proxy(self, proxy, puser_pass):
		self.proxy = proxy
		self.puser_pass = puser_pass
	def make_connection(self, host):
		self.realhost = host
		h = httplib.HTTP(self.proxy)
		return h
	def send_request(self, connection, handler, request_body):
		connection.putrequest("POST", 'http://%s%s' % (self.realhost, handler))
	def send_host(self, connection, host):
		connection.putheader('Host', self.realhost)
		connection.putheader('User-agent', self.user_agent)
		if len(self.puser_pass.strip()) != 0:
			connection.putheader('Proxy-authorization','Basic '+self.puser_pass)

